#
# spec file for package mediatomb
#
# Copyright (c) 2007-2010 oc2pus toni@links2linux.de.
# Copyright (c) 2012 Marguerite i@marguerite.su.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.links2linux.org/
#

Name:           mediatomb
Version:        0.12.1.svn2103
Release:        14.1
License:        GPL-2.0
Summary:        UPnP AV MediaServer
Url:            http://mediatomb.cc
Group:          Productivity/Multimedia/Other
Source0:        %{name}-%{version}.tar.bz2
Source1:        rcmediatomb
Source2:        config.xml.tmp
Patch0:         libav_0.7_support.patch
# PATCH-FIX-UPSTREAM - fix gcc 4.6 builds.
Patch1:         mediatomb-0.12.1-gcc46.patch
# PATCH-FIX-UPSTREAM - fix automake 1.12 configure
Patch2:		mediatomb-svn_automake_1.12.patch
# PATCH-FIX-UPSTREAM - fix mozjs185 builds.
Patch3:		mediatomb-0.12.1-mozjs185.patch
# PATCH-FIX-UPSTREAM - fix gcc47 builds.
Patch4:		mediatomb-0.12.1-gcc47.patch
# PATCH-FIX-UPSTREAM - port to libextractor 0.6 series
Patch5:		mediatomb-0.12.1-libextractor-0.6.patch
# PATCH-FIX-UPSTREAM - build with ffmpeg new API
Patch6:         libavformat_0.11_support.patch
# PATCH-FIX-UPSTREAM - build with mp4v2 >= 2.0.0
Patch7:		mediatomb-0.12.1-mp4v2_2.0.0.patch
Source90:       %{name}-rpmlintrc
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  file-devel
BuildRequires:  gcc-c++
BuildRequires:	libcurl-devel
BuildRequires:  libexpat-devel
# Multimedia has no extractor package.
#BuildRequires:	libextractor-devel
BuildRequires:  pkgconfig(libavformat)
BuildRequires:  libffmpegthumbnailer-devel
BuildRequires:  libjack-devel
# it requires lastfmlib, not the same one.
#BuildRequires:  liblastfm-devel
BuildRequires:  libmysqlclient-devel
BuildRequires:  libtag-devel
BuildRequires:  mDNSResponder-lib
BuildRequires:  mozilla-nspr
BuildRequires:  pwdutils
BuildRequires:  sqlite3-devel
BuildRequires:  udev
BuildRequires:  pkgconfig(libexif)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  js-devel

Requires:       %{name}-dbbackend = %{version}-%{release}
Requires:       logrotate
Requires(pre):	%insserv_prereq
Requires(pre):	coreutils
Requires(pre):	sed
Requires(pre):	iproute
Requires(pre):	pwdutils

%description
MediaTomb - UPnP AV Mediaserver for Linux.

MediaTomb is an open source (GPL) UPnP MediaServer with a nice
web user interface, it allows you to stream your digital media
through your home network and listen to/watch it on a variety
of UPnP compatible devices.

MediaTomb implements the UPnP MediaServer V 1.0 specification
that can be found on http://www.upnp.org/. The current
implementation focuses on parts that are required by the
specification, however we look into extending the functionality
to cover the optional parts of the spec as well.

MediaTomb should work with any UPnP compliant MediaRenderer,
please tell us if you experience difficulties with particular
models, also take a look at the Supported Devices list for more
information.

This package contains the shared data for mediatomb. You need
addionally one db backend: mediatom-sqlite or mediatomb-mysql

%package mysql
Summary:        UPnP AV MediaServer mysql
Group:          Productivity/Multimedia/Other
Requires:       %{name} = %{version}-%{release}
Requires:       mysql
Provides:       %{name}-dbbackend = %{version}-%{release}
Requires(pre):	coreutils
Conflicts:      %{name}-sqlite

%description mysql
MediaTomb - UPnP AV Mediaserver for Linux.

MediaTomb is an open source (GPL) UPnP MediaServer with a nice
web user interface, it allows you to stream your digital media
through your home network and listen to/watch it on a variety
of UPnP compatible devices.

MediaTomb implements the UPnP MediaServer V 1.0 specification
that can be found on http://www.upnp.org/. The current
implementation focuses on parts that are required by the
specification, however we look into extending the functionality
to cover the optional parts of the spec as well.

MediaTomb should work with any UPnP compliant MediaRenderer,
please tell us if you experience difficulties with particular
models, also take a look at the Supported Devices list for more
information.

This package contains a mysql AND sqlite enabled binary.

%package sqlite
Summary:        UPnP AV MediaServer sqlite
Group:          Productivity/Multimedia/Other
Requires:       %{name} = %{version}-%{release}
Requires:       sqlite
Provides:       %{name}-dbbackend = %{version}-%{release}
Requires(pre):	coreutils
Conflicts:      %{name}-mysql

%description sqlite
MediaTomb - UPnP AV Mediaserver for Linux.

MediaTomb is an open source (GPL) UPnP MediaServer with a nice
web user interface, it allows you to stream your digital media
through your home network and listen to/watch it on a variety
of UPnP compatible devices.

MediaTomb implements the UPnP MediaServer V 1.0 specification
that can be found on http://www.upnp.org/. The current
implementation focuses on parts that are required by the
specification, however we look into extending the functionality
to cover the optional parts of the spec as well.

MediaTomb should work with any UPnP compliant MediaRenderer,
please tell us if you experience difficulties with particular
models, also take a look at the Supported Devices list for more
information.

This package contains a sqlite enabled binary.

%prep
%setup -q %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

cp %{SOURCE2} .

%build
# add subdir-objects option
sed '/AM_INIT_AUTOMAKE/s/\(-Wall\)/\1 subdir-objects/' -i configure.ac
# we patched configure.ac
autoreconf -if

%install

###################
# build the sqlite/mysql enabled mediatomb
%configure \
	--prefix=%{_prefix} \
	--enable-sqlite3 \
	--enable-mysql \
	--enable-curl \
	--enable-ffmpeg \
	--enable-libmagic \
	--enable-libexif \
	--enable-inotify \
	--enable-libjs \
	--enable-taglib 

make %{?_smp_flags}
%makeinstall \
	INSTALL="install -p"
mv %{buildroot}%{_bindir}/mediatomb \
	%{buildroot}%{_bindir}/mediatomb-mysql

###################
# build the sqlite enabled mediatomb
make clean
%configure \
	--prefix=%{_prefix} \
	--enable-sqlite3 \
	--disable-mysql \
	--enable-curl \
	--enable-ffmpeg \
	--enable-libmagic \
	--enable-libexif \
	--enable-inotify \
	--enable-libjs \
	--enable-taglib 
make %{?_smp_flags}

%makeinstall \
	INSTALL="install -p"
mv %{buildroot}%{_bindir}/mediatomb \
	%{buildroot}%{_bindir}/mediatomb-sqlite

###################
# init script
install -dm 755 %{buildroot}%{_sbindir}
install -dm 755 %{buildroot}%{_sysconfdir}/init.d
install -m 755 %{SOURCE1} \
	%{buildroot}%{_sysconfdir}/init.d/mediatomb
install -m 755 config/mediatomb-conf-fedora \
	%{buildroot}%{_sysconfdir}/mediatomb.conf
ln -s ../../%{_sysconfdir}/init.d/%{name} \
	%{buildroot}%{_sbindir}/rcmediatomb

###################
# sample config
install -dm 755 %{buildroot}%{_sysconfdir}/%{name}
install -m 644 %{SOURCE2} \
	%{buildroot}%{_sysconfdir}/%{name}/config.xml

###################
# create a new home
install -dm 755 %{buildroot}%{_localstatedir}/lib/%{name}
install -m 644 %{SOURCE1} \
	%{buildroot}%{_localstatedir}/lib/%{name}/config.xml
touch %{buildroot}%{_localstatedir}/lib/%{name}/{config.xml,mediatomb.db,mediatomb.html}

###################
# logrotate
install -dm 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/%{name} << 'EOF'
/var/log/mediatomb {
create 644 root root
	monthly
        compress
        missingok
}
EOF

%clean
%{?buildroot:rm -rf %{buildroot}}

%pre
# create group if necessary
/usr/bin/getent group mediatomb >/dev/null || \
	/usr/sbin/groupadd -r mediatomb

# create user
/usr/bin/getent passwd mediatomb >/dev/null || \
	/usr/sbin/useradd \
		-s /sbin/nologin \
		-r \
		-d %{_localstatedir}/lib/%{name} \
		-G mediatomb \
		mediatomb > /dev/null 2> /dev/null || :

%preun
%stop_on_removal mediatomb
# if removal and not upgrade clean up
if test "$1" -eq 0 ; then
	/usr/sbin/userdel -r -f mediatomb > /dev/null 2> /dev/null || :
	/usr/sbin/groupdel      mediatomb > /dev/null 2> /dev/null || :
fi

%postun
if test "$1" = 0 ; then
rm -fv "%{_bindir}/mediatomb"
fi
%restart_on_update mediatomb
%insserv_cleanup

%pre sqlite
# create group if necessary
/usr/bin/getent group mediatomb >/dev/null || \
	/usr/sbin/groupadd -r mediatomb

# create user
/usr/bin/getent passwd mediatomb >/dev/null || \
	/usr/sbin/useradd \
		-s /sbin/nologin \
		-r \
		-d %{_localstatedir}/lib/%{name} \
		-G mediatomb \
		mediatomb > /dev/null 2> /dev/null || :

%post sqlite
if test "$1" != 0 ; then
ln -sfv "mediatomb-sqlite" "%{_bindir}/mediatomb"
fi

%post mysql
if test "$1" != 0 ; then
ln -sfv "mediatomb-mysql" "%{_bindir}/mediatomb"
fi

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING README*
%doc doc/scripting*
%attr(0660,mediatomb,mediatomb) %config(noreplace) %{_sysconfdir}/%{name}.conf
%attr(0750,mediatomb,mediatomb) %dir %{_sysconfdir}/%{name}
%attr(0660,mediatomb,mediatomb) %config(noreplace) %{_sysconfdir}/%{name}/config.xml
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/init.d/%{name}
%{_sbindir}/rcmediatomb
%{_datadir}/%{name}/
%{_mandir}/man1/*

%files mysql
%defattr(-,root,root)
%{_bindir}/mediatomb-mysql

%files sqlite
%defattr(-,root,root)
%{_bindir}/mediatomb-sqlite
%attr(750,mediatomb,mediatomb) %dir %{_localstatedir}/lib/%{name}
%attr(0660,mediatomb,mediatomb) %{_localstatedir}/lib/%{name}/*

%changelog
* Mon Mar 20 2017 olaf@aepfle.de
- Fix symlink handling in post install scripts
* Sun Mar 12 2017 olaf@aepfle.de
- Disable mp4 because libmp4v2 was dropped
* Tue Dec  8 2015 olaf@aepfle.de
- Remove ffmpeg from BuildRequires
* Sat Dec 20 2014 seife+obs@b1-systems.com
- do not require xulrunner, it does not seeem necessary and is
  not available on openSUSE 13.2
* Sun Nov 23 2014 avvissu@yandex.ru
- Fix build error on openSUSE > 13.2:
  * add subdir-objects option to AM_INIT_AUTOMAKE
* Fri Aug  9 2013 obs@botter.cc
- add patch to have mediatomb 0.12.1 compile against mp4v2 >= 2.0.0
* Mon Dec 10 2012 lang@b1-systems.de
- openSUSE 12.2 compat: Do not assume the dir for the pid file just exists
* Fri Nov  9 2012 i@margueirte.su
- fix libjs dependency.
- update source to svn2103.
- add mediatomb-svn_automake_1.12.patch, fix automake 1.12+ configure.
- add mediatomb-0.12.1-mozjs185.patch, fix mozjs185 builds.
- add mediatomb-0.12.1-gcc47.patch, fix gcc47 builds.
- add mediatomb-0.12.1-libextractor-0.6.patch, fix libextractor-0.6 builds.
- build against new ffmpeg.
- disable spidermonkey support on 11.4-, not possible.
* Thu May 31 2012 Manfred.Tremmel@iiv.de
- ffmpeg calls are outdated, compile against ffmpeg_oldabi
* Sun Nov 20 2011 pascal.bleser@opensuse.org
- fix build on 12.1+ by applying mediatomb-0.12.1-gcc46.patch
  http://sourceforge.net/tracker/index.php?func=detail&aid=3173314&group_id=129766&atid=715782
* Mon Oct 17 2011 pascal.bleser@opensuse.org
- fixes to init script when binary is not present
- require versioned backend
* Thu Jun 23 2011 Manfred.Tremmel@iiv.de
- included a patch to compile against new ffmpeg abi taken from
  https://launchpadlibrarian.net/71985647/libav_0.7_support.patch
* Wed May  5 2010 toni@links2linux.de
- update to 0.12.1
* Mon Apr  5 2010 toni@links2linux.de
- update to 0.12.0
- changes see http://mediatomb.cc/changelog.txt
* Sat Mar  6 2010 toni@links2linux.de
- modified rcmediatomb (nobody ==> $MT_USER) (thx to Dieter Landolt)
* Sun Jan  3 2010 toni@links2linux.de
- fixed libjs(-devel) support
* Mon Nov 16 2009 toni@links2linux.de
- Added upstream patch which fixes compile time errors and a couple of segfaults
* Thu Sep 24 2009 Manfred.Tremmel@iiv.de
- rebuild against new ffmpeg version
- removed libjs support because libjs didn't compile on OBS
* Mon May  5 2008 toni@links2linux.de
- added check for symlink to binary prior to create link
- added user and group mediatomb
- added logrotate entry
- thx for testing this package-layout goes to George Pantazis
* Thu May  1 2008 toni@links2linux.de
- added a sample config for mediatomb
  provided by George Pantazis, thx!
* Sun Mar  2 2008 toni@links2linux.de
- update to 0.11.0
- switched to taglib instead of id3lib
- switched to ffmpeg instead of libextractor
- enabled curl
* Sun Dec  9 2007 toni@links2linux.de
- rebuild with new libjs
* Sun Nov 11 2007 toni@links2linux.de
- initial build 0.10.0
